#!/usr/bin/env python
# coding=UTF-8
#
# Copyright (C) 2010 Stefanos Harhalakis
#
# This file is part of wifieye.
#
# wifieye is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# wifieye is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with wifieye.  If not, see <http://www.gnu.org/licenses/>.
#
# $Id: wifi.py 2265 2010-02-21 19:16:26Z v13 $

__version__ = "$Id: wifi.py 2265 2010-02-21 19:16:26Z v13 $"

from PyQt4 import QtCore
from PyQt4.QtCore import Qt

import pickle, subprocess
import os

import config

fakedata={'00:1D:7E:0D:41:99': {'bssid': '00:1D:7E:0D:41:99', 'rates': [[1000000, 2000000, 5500000, 11000000, 6000000, 9000000, 12000000, 18000000, 24000000, 36000000, 48000000, 54000000]], 'essid': 'V13-Home', 'freq': {'m': 2412, 'e': 6}, 'quality': {'signal': 210, 'noise': 165, 'quality': 75}, 'mode': 'Master'}, '00:14:BF:6F:C3:99': {'bssid': '00:14:BF:6F:C3:99', 'rates': [[1000000, 2000000, 5500000, 11000000, 22000000, 6000000, 9000000, 12000000, 18000000, 24000000, 36000000, 48000000, 54000000]], 'essid': 'MANOLAS-NET', 'freq': {'m': 2462, 'e': 6}, 'quality': {'signal': 169, 'noise': 166, 'quality': 12}, 'mode': 'Master'}, '00:05:59:0B:71:99': {'bssid': '00:05:59:0B:71:99', 'rates': [[1000000, 2000000, 5500000, 11000000, 22000000, 6000000, 9000000, 12000000, 18000000, 24000000, 36000000, 48000000, 54000000]], 'essid': 'NetFasteR IAD (PSTN)', 'freq': {'m': 2437, 'e': 6}, 'quality': {'signal': 167, 'noise': 164, 'quality': 9}, 'mode': 'Master'}}

asyncthread=None

def scan():
    if config.nosudo:
	dt=fakedata
    else:
	#d=os.path.dirname(os.path.realpath(__file__))
	#cmd=["sudo", d+"/wifi-su.py"]
	cmd=["sudo", "/usr/bin/wifieye-su"]
	c0=subprocess.Popen(cmd, stdout=subprocess.PIPE)
	c=c0.communicate()[0]
	dt=pickle.loads(c)

    return(dt)

class ScanThread(QtCore.QThread):
    def __init__(self, cb):
	QtCore.QThread.__init__(self)
	self.cb=cb
	self.dt={}
	self.connect(self, QtCore.SIGNAL('gotdata'), self.signalGotdata,
	    Qt.QueuedConnection)

    def run(self):
	#import time
	#t0=time.time()
	dt=scan()
	#t1=time.time()
	#print "Time:", t1-t0
	self.dt=dt
	self.emit(QtCore.SIGNAL("gotdata"))

    def signalGotdata(self):
	global asyncthread

	self.cb(self.dt)

	self.wait()
	asyncthread=None

# Start a thread to perform scanning. Call the callback when finished
# return: False if a scan is already active, True if not
def scanAsync(cb):
    global asyncthread

    if asyncthread!=None:
	#print "Already scanning"
	return False

    asyncthread=ScanThread(cb)
    asyncthread.start()

    return True

# This must be called if at least one async was used in order to wait
# for the thread to finish
def finish():
    global asyncthread

    if asyncthread!=None:
	asyncthread.wait()

if __name__=="__main__":
    import sys, time

    print "Doing async"

    app=QtCore.QCoreApplication(sys.argv)

    def show(dt):
	print
	print "Results:"
	print
	for i in dt:
	    print i
	    for k in dt[i]:
		print "   %s: " % k, dt[i][k]
	    print
	print
	app.quit()
	finish()

    #print scan()
    scanAsync(show)
    sys.exit(app.exec_())

# vim: set ts=8 sts=4 sw=4 noet formatoptions=r ai nocindent:

